﻿; Initial Script generated by the Inno Setup Script Wizard.
; SEE THE DOCUMENTATION FOR DETAILS ON CREATING INNO SETUP SCRIPT FILES!

; Money Manager Ex InnoSetup script
;
; This file encoded as UTF-8.
; UTF-8 enables custom messages in other languages.
; Initial script modified using various strings and ideas by previous developers

; Copyright (C) 2006 Madhan Kanagavel
; Copyright (C) 2009 VaDiM
; Copyright (C) 2011-2017 Stefano Giorgio
; Copyright (C) 2013 James Higley
; Copyright (C) 2012-2017 Nikolay

; Note: MyWinVersionInfo - use numbers only
#define MyWinVersionInfo "1.3.3"

#define MyAppVersion "1.3.3"
#define MyAppName "MoneyManagerEX"
#define MyAppExeName "mmex.exe"
#define MyAppPublisher "Money Manager EX"
#define MyAppURL "http://www.moneymanagerex.org"

; Set this value to a nul string for release version
#define MyAppDevelopVersion ""


;===============================================================================
; Local definitions
#define my_output_root "..\..\mmex_release"

; Note: This is the path where MMEX.exe will be found
#define my_output_path "\mmex_1.3.3_win32_portable\MoneyManagerEx"

; Note: Any revision mods can be added here
#define my_output_filename "mmex_1.3.3_win32_setup"

;===============================================================================

[Setup]
; NOTE: The value of AppId uniquely identifies this application.
; Do not use the same AppId value in installers for other applications.
; (To generate a new GUID, click Tools | Generate GUID inside the IDE.)

; Release ID
AppId={{2C48DC11-E113-4912-8AFC-366D1918101E}

AppName={#MyAppName}{#MyAppDevelopVersion}
AppVersion={#MyAppVersion}{#MyAppDevelopVersion}
AppVerName={#MyAppName} {#MyAppVersion}
AppPublisher={#MyAppPublisher}
AppPublisherURL={#MyAppURL}
AppSupportURL={#MyAppURL}
AppUpdatesURL={#MyAppURL}
DefaultDirName={pf}\{#MyAppName}{#MyAppDevelopVersion}
DefaultGroupName={#MyAppName}{#MyAppDevelopVersion}
LicenseFile={#my_output_root}{#my_output_path}\license.txt
InfoBeforeFile={#my_output_root}{#my_output_path}\README.TXT
InfoAfterFile={#my_output_root}{#my_output_path}\version.txt
OutputDir={#my_output_root}
OutputBaseFilename={#my_output_filename}
SetupIconFile={#my_output_root}{#my_output_path}\res\mmex.ico
UninstallDisplayIcon={app}\bin\{#MyAppExeName},0

Compression=lzma/Max
SolidCompression=true
VersionInfoVersion={#MyWinVersionInfo}.0
VersionInfoCompany=Money Manager EX
VersionInfoDescription=Money Management Software
VersionInfoTextVersion={#MyWinVersionInfo}.0
VersionInfoCopyright=2016 - Money Manager EX
VersionInfoProductName=mmex
VersionInfoProductVersion={#MyWinVersionInfo}.0
VersionInfoProductTextVersion={#MyWinVersionInfo}.0

[Languages]
Name: "english"; MessagesFile: "compiler:Default.isl"
Name: "basque"; MessagesFile: "compiler:Languages\Basque.isl"
Name: "brazilianportuguese"; MessagesFile: "compiler:Languages\BrazilianPortuguese.isl"
Name: "catalan"; MessagesFile: "compiler:Languages\Catalan.isl"
Name: "corsican"; MessagesFile: "compiler:Languages\Corsican.isl"
Name: "czech"; MessagesFile: "compiler:Languages\Czech.isl"
Name: "danish"; MessagesFile: "compiler:Languages\Danish.isl"
Name: "dutch"; MessagesFile: "compiler:Languages\Dutch.isl"
Name: "finnish"; MessagesFile: "compiler:Languages\Finnish.isl"
Name: "french"; MessagesFile: "compiler:Languages\French.isl"
Name: "german"; MessagesFile: "compiler:Languages\German.isl"
Name: "greek"; MessagesFile: "compiler:Languages\Greek.isl"
Name: "hebrew"; MessagesFile: "compiler:Languages\Hebrew.isl"
Name: "hungarian"; MessagesFile: "compiler:Languages\Hungarian.isl"
Name: "italian"; MessagesFile: "compiler:Languages\Italian.isl"
Name: "japanese"; MessagesFile: "compiler:Languages\Japanese.isl"
Name: "norwegian"; MessagesFile: "compiler:Languages\Norwegian.isl"
Name: "polish"; MessagesFile: "compiler:Languages\Polish.isl"
Name: "portuguese"; MessagesFile: "compiler:Languages\Portuguese.isl"
Name: "russian"; MessagesFile: "compiler:Languages\Russian.isl"
Name: "scottishgaelic"; MessagesFile: "compiler:Languages\ScottishGaelic.isl"
Name: "serbiancyrillic"; MessagesFile: "compiler:Languages\SerbianCyrillic.isl"
Name: "serbianlatin"; MessagesFile: "compiler:Languages\SerbianLatin.isl"
Name: "slovak"; MessagesFile: "compiler:Languages\Slovak.isl"
Name: "slovenian"; MessagesFile: "compiler:Languages\Slovenian.isl"
Name: "spanish"; MessagesFile: "compiler:Languages\Spanish.isl"
Name: "turkish"; MessagesFile: "compiler:Languages\Turkish.isl"
Name: "ukrainian"; MessagesFile: "compiler:Languages\Ukrainian.isl"


[Types]
Name: full;    Description: "Full Installation"; 
Name: minimal; Description: "Minimal Installation"; 
Name: custom;  Description: "Custom Installation"; Flags: IsCustom; 

[Components]
Name: program; Description: "Program Files"; Types: full minimal custom; Flags: fixed; 
Name: local; Description: "Make portable: Include mmexini.db3 file in MMEX directory"; Flags: checkablealone;

; Add language component here then add language file in files section
Name: help; Description: "Help files"; Types: full minimal; 
Name: lang; Description: Languages; Types: full; 
Name: lang\english; Description: English; Types: full; 
Name: lang\abkhazian; Description: Abkhazian; Types: full; 
Name: lang\albanian; Description: Albanian; Types: full; 
Name: lang\arabic; Description: Arabic; Types: full; 
Name: lang\bulgarian; Description: Bulgarian; Types: full; 
Name: lang\burmese; Description: Burmese; Types: full; 
Name: lang\catalan; Description: "Catalan"; Types: full; 
Name: lang\chinese_chs; Description: "Chinese Chs"; Types: full; 
Name: lang\chinese_zh; Description: "Chinese Zh"; Types: full; 
Name: lang\croatian; Description: Croatian; Types: full; 
Name: lang\czech; Description: Czech; Types: full; 
Name: lang\ducth; Description: Dutch; Types: full; 
Name: lang\dutch_be; Description: "Dutch Be"; Types: full; 
Name: lang\english_uk; Description: "English UK"; Types: full; 
Name: lang\finnish; Description: Finnish; Types: full; 
Name: lang\french; Description: French; Types: full; 
Name: lang\german; Description: German; Types: full; 
Name: lang\greek; Description: Greek; Types: full; 
Name: lang\hebrew; Description: Hebrew; Types: full; 
Name: lang\hindi; Description: Hindi; Types: full; 
Name: lang\hungarian; Description: Hungarian; Types: full; 
Name: lang\indonesian; Description: Indonesian; Types: full; 
Name: lang\italian; Description: Italian; Types: full; 
Name: lang\japanese; Description: Japanese; Types: full;
Name: lang\korean; Description: Korean; Types: full; 
Name: lang\latvian; Description: Latvian; Types: full; 
Name: lang\lithuanian; Description: Lithuanian; Types: full; 
Name: lang\malayalam; Description: Malayalam; Types: full; 
Name: lang\norwegian; Description: Norwegian; Types: full; 
Name: lang\persian; Description: Persian; Types: full; 
Name: lang\polish; Description: Polish; Types: full; 
Name: lang\portuguese; Description: Portuguese; Types: full; 
Name: lang\portuguese_portugal; Description: "Portuguese Portugal"; Types: full; 
Name: lang\romanian; Description: Romanian; Types: full; 
Name: lang\russian; Description: Russian; Types: full; 
Name: lang\serbo_croatian; Description: "Serbo Croatian"; Types: full; 
Name: lang\serbian; Description: Serbian; Types: full; 
Name: lang\slovak; Description: Slovak; Types: full; 
Name: lang\slovenian; Description: Slovenian; Types: full; 
Name: lang\spanish; Description: Spanish; Types: full; 
Name: lang\swedish; Description: Swedish; Types: full; 
Name: lang\tamil; Description: Tamil; Types: full; 
Name: lang\thai; Description: Thai; Types: full; 
Name: lang\turkish; Description: Turkish; Types: full; 
Name: lang\ukrainian; Description: Ukrainian; Types: full; 
Name: lang\vietnamese; Description: Vietnamese; Types: full; 

[Tasks]
Name: desktopicon; Description: {cm:CreateDesktopIcon}; GroupDescription: {cm:AdditionalIcons}; 
Name: quicklaunchicon; Description: {cm:CreateQuickLaunchIcon}; GroupDescription: {cm:AdditionalIcons}; Flags: unchecked; 

[Registry]
Root: HKCU; Subkey: "Software\Microsoft\Internet Explorer\Main\FeatureControl\FEATURE_BROWSER_EMULATION"; ValueType: dword; ValueName: "mmex.exe"; ValueData: "9000"; Flags: createvalueifdoesntexist

[Files]
; NOTE: Don't use "Flags: ignoreversion" on any shared system files

; MMEX Executable files 
Source: {#my_output_root}{#my_output_path}\bin\mmex.exe; DestDir: {app}\bin; Flags: ignoreversion; Components: program; 
Source: {#my_output_root}{#my_output_path}\bin\msvcp140.dll; DestDir: {app}\bin; Flags: ignoreversion; Components: program; 
Source: {#my_output_root}{#my_output_path}\bin\vcruntime140.dll; DestDir: {app}\bin; Flags: ignoreversion; Components: program;

; MMEX Root files
Source: {#my_output_root}{#my_output_path}\contrib.txt; DestDir: {app}; Flags: ignoreversion; Components: program; 
Source: {#my_output_root}{#my_output_path}\license.txt; DestDir: {app}; Flags: ignoreversion; Components: program; 
Source: {#my_output_root}{#my_output_path}\version.txt; DestDir: {app}; Flags: ignoreversion; Components: program; 

; Include in directory if user requires a local setup
Source: {#my_output_root}{#my_output_path}\mmexini.db3; DestDir: {app}; Flags: ignoreversion; Components: local;

; MMEX Resource files
Source: {#my_output_root}{#my_output_path}\res\ChartNew.js; DestDir: {app}\res; Flags: ignoreversion; 
Source: {#my_output_root}{#my_output_path}\res\home_page.htt; DestDir: {app}\res; Flags: ignoreversion; 
Source: {#my_output_root}{#my_output_path}\res\kaching.wav; DestDir: {app}\res; Flags: ignoreversion; 
Source: {#my_output_root}{#my_output_path}\res\master.css; DestDir: {app}\res; Flags: ignoreversion; 
Source: {#my_output_root}{#my_output_path}\res\mmex.ico; DestDir: {app}\res; Flags: ignoreversion; 
Source: {#my_output_root}{#my_output_path}\res\sorttable.js; DestDir: {app}\res; Flags: ignoreversion; 

; MMEX Root files - language dependant
Source: {#my_output_root}{#my_output_path}\README.TXT; DestDir: {app}; Flags: ignoreversion; Components: program; Languages: english; 

; MMEX Language Files - Determined by Component
Source: {#my_output_root}{#my_output_path}\po\en\arabic.mo; DestDir: {app}\po\en; Flags: ignoreversion; Components: lang\arabic; 
Source: {#my_output_root}{#my_output_path}\po\en\abkhazian.mo; DestDir: {app}\po\en; Flags: ignoreversion; Components: lang\abkhazian; 
Source: {#my_output_root}{#my_output_path}\po\en\albanian.mo; DestDir: {app}\po\en; Flags: ignoreversion; Components: lang\albanian; 
Source: {#my_output_root}{#my_output_path}\po\en\bulgarian.mo; DestDir: {app}\po\en; Flags: ignoreversion; Components: lang\bulgarian; 
Source: {#my_output_root}{#my_output_path}\po\en\burmese.mo; DestDir: {app}\po\en; Flags: ignoreversion; Components: lang\burmese; 
Source: {#my_output_root}{#my_output_path}\po\en\catalan.mo; DestDir: {app}\po\en; Flags: ignoreversion; Components: lang\catalan; 
Source: {#my_output_root}{#my_output_path}\po\en\chinese_chs.mo; DestDir: {app}\po\en; Flags: ignoreversion; Components: lang\chinese_chs; 
Source: {#my_output_root}{#my_output_path}\po\en\chinese_zh.mo; DestDir: {app}\po\en; Flags: ignoreversion; Components: lang\chinese_zh; 
Source: {#my_output_root}{#my_output_path}\po\en\croatian.mo; DestDir: {app}\po\en; Flags: ignoreversion; Components: lang\croatian; 
Source: {#my_output_root}{#my_output_path}\po\en\czech.mo; DestDir: {app}\po\en; Flags: ignoreversion; Components: lang\czech; 
Source: {#my_output_root}{#my_output_path}\po\en\dutch.mo; DestDir: {app}\po\en; Flags: ignoreversion; Components: lang\ducth; 
Source: {#my_output_root}{#my_output_path}\po\en\dutch_be.mo; DestDir: {app}\po\en; Flags: ignoreversion; Components: lang\dutch_be;
Source: {#my_output_root}{#my_output_path}\po\en\english.mo; DestDir: {app}\po\en; Flags: ignoreversion; Components: lang\english; 
Source: {#my_output_root}{#my_output_path}\po\en\english.mo; DestDir: {app}\po\en; Flags: ignoreversion; Components: help; Languages: english; 
Source: {#my_output_root}{#my_output_path}\po\en\english-uk.mo; DestDir: {app}\po\en; Flags: ignoreversion; Components: lang\english_uk; 
Source: {#my_output_root}{#my_output_path}\po\en\finnish.mo; DestDir: {app}\po\en; Flags: ignoreversion; Components: lang\finnish; 
Source: {#my_output_root}{#my_output_path}\po\en\french.mo; DestDir: {app}\po\en; Flags: ignoreversion; Components: lang\french; 
Source: {#my_output_root}{#my_output_path}\po\en\german.mo; DestDir: {app}\po\en; Flags: ignoreversion; Components: lang\german; 
Source: {#my_output_root}{#my_output_path}\po\en\greek.mo; DestDir: {app}\po\en; Flags: ignoreversion; Components: lang\greek; 
Source: {#my_output_root}{#my_output_path}\po\en\hebrew.mo; DestDir: {app}\po\en; Flags: ignoreversion; Components: lang\hebrew;
Source: {#my_output_root}{#my_output_path}\po\en\hindi.mo; DestDir: {app}\po\en; Flags: ignoreversion; Components: lang\hindi;
Source: {#my_output_root}{#my_output_path}\po\en\hungarian.mo; DestDir: {app}\po\en; Flags: ignoreversion; Components: lang\hungarian; 
Source: {#my_output_root}{#my_output_path}\po\en\indonesian.mo; DestDir: {app}\po\en; Flags: ignoreversion; Components: lang\indonesian; 
Source: {#my_output_root}{#my_output_path}\po\en\italian.mo; DestDir: {app}\po\en; Flags: ignoreversion; Components: lang\italian;
Source: {#my_output_root}{#my_output_path}\po\en\japanese.mo; DestDir: {app}\po\en; Flags: ignoreversion; Components: lang\japanese;
Source: {#my_output_root}{#my_output_path}\po\en\korean.mo; DestDir: {app}\po\en; Flags: ignoreversion; Components: lang\korean; 
Source: {#my_output_root}{#my_output_path}\po\en\latvian.mo; DestDir: {app}\po\en; Flags: ignoreversion; Components: lang\latvian; 
Source: {#my_output_root}{#my_output_path}\po\en\lithuanian.mo; DestDir: {app}\po\en; Flags: ignoreversion; Components: lang\lithuanian; 
Source: {#my_output_root}{#my_output_path}\po\en\malayalam.mo; DestDir: {app}\po\en; Flags: ignoreversion; Components: lang\malayalam; 
Source: {#my_output_root}{#my_output_path}\po\en\norwegian.mo; DestDir: {app}\po\en; Flags: ignoreversion; Components: lang\norwegian; 
Source: {#my_output_root}{#my_output_path}\po\en\persian.mo; DestDir: {app}\po\en; Flags: ignoreversion; Components: lang\persian; 
Source: {#my_output_root}{#my_output_path}\po\en\polish.mo; DestDir: {app}\po\en; Flags: ignoreversion; Components: lang\polish; 
Source: {#my_output_root}{#my_output_path}\po\en\portuguese.mo; DestDir: {app}\po\en; Flags: ignoreversion; Components: lang\portuguese; 
Source: {#my_output_root}{#my_output_path}\po\en\portuguese_portugal.mo; DestDir: {app}\po\en; Flags: ignoreversion; Components: lang\portuguese_portugal; 
Source: {#my_output_root}{#my_output_path}\po\en\romanian.mo; DestDir: {app}\po\en; Flags: ignoreversion; Components: lang\romanian; 
Source: {#my_output_root}{#my_output_path}\po\en\russian.mo; DestDir: {app}\po\en; Flags: ignoreversion; Components: lang\russian; 
Source: {#my_output_root}{#my_output_path}\po\en\serbian.mo; DestDir: {app}\po\en; Flags: ignoreversion; Components: lang\serbian; 
Source: {#my_output_root}{#my_output_path}\po\en\serbo-croatian.mo; DestDir: {app}\po\en; Flags: ignoreversion; Components: lang\serbo_croatian; 
Source: {#my_output_root}{#my_output_path}\po\en\slovak.mo; DestDir: {app}\po\en; Flags: ignoreversion; Components: lang\slovak; 
Source: {#my_output_root}{#my_output_path}\po\en\slovenian.mo; DestDir: {app}\po\en; Flags: ignoreversion; Components: lang\slovenian; 
Source: {#my_output_root}{#my_output_path}\po\en\spanish.mo; DestDir: {app}\po\en; Flags: ignoreversion; Components: lang\spanish; 
Source: {#my_output_root}{#my_output_path}\po\en\swedish.mo; DestDir: {app}\po\en; Flags: ignoreversion; Components: lang\swedish; 
Source: {#my_output_root}{#my_output_path}\po\en\tamil.mo; DestDir: {app}\po\en; Flags: ignoreversion; Components: lang\tamil; 
Source: {#my_output_root}{#my_output_path}\po\en\thai.mo; DestDir: {app}\po\en; Flags: ignoreversion; Components: lang\thai; 
Source: {#my_output_root}{#my_output_path}\po\en\turkish.mo; DestDir: {app}\po\en; Flags: ignoreversion; Components: lang\turkish; 
Source: {#my_output_root}{#my_output_path}\po\en\ukrainian.mo; DestDir: {app}\po\en; Flags: ignoreversion; Components: lang\ukrainian; 
Source: {#my_output_root}{#my_output_path}\po\en\vietnamese.mo; DestDir: {app}\po\en; Flags: ignoreversion; Components: lang\vietnamese; 

; MMEX Help - Root Help files 
Source: {#my_output_root}{#my_output_path}\help\*.html; DestDir: {app}\help; Flags: ignoreversion; Components: help;
Source: {#my_output_root}{#my_output_path}\help\*.png; DestDir: {app}\help; Flags: ignoreversion; Components: help;
Source: {#my_output_root}{#my_output_path}\help\*.gif; DestDir: {app}\help; Flags: ignoreversion; Components: help;
 
; MMEX Help - Help Directories - Language dependant
Source: {#my_output_root}{#my_output_path}\help\french\*; DestDir: {app}\help\french; Flags: ignoreversion recursesubdirs createallsubdirs; Components: lang\french; 
; Source: {#my_output_root}{#my_output_path}\help\german\*; DestDir: {app}\help\german; Flags: ignoreversion recursesubdirs createallsubdirs; Components: lang\german; 
Source: {#my_output_root}{#my_output_path}\help\hungarian\*; DestDir: {app}\help\hungarian; Flags: ignoreversion recursesubdirs createallsubdirs; Components: lang\hungarian; 
Source: {#my_output_root}{#my_output_path}\help\italian\*; DestDir: {app}\help\italian; Flags: ignoreversion recursesubdirs createallsubdirs; Components: lang\italian; 
Source: {#my_output_root}{#my_output_path}\help\polish\*; DestDir: {app}\help\polish; Flags: ignoreversion recursesubdirs createallsubdirs; Components: lang\polish; 
Source: {#my_output_root}{#my_output_path}\help\russian\*; DestDir: {app}\help\russian; Flags: ignoreversion recursesubdirs createallsubdirs; Components: lang\russian; 
Source: {#my_output_root}{#my_output_path}\help\spanish\*; DestDir: {app}\help\spanish; Flags: ignoreversion recursesubdirs createallsubdirs; Components: lang\spanish; 


[Icons]
Name: {group}\{#MyAppName}{#MyAppDevelopVersion}; Filename: {app}\bin\{#MyAppExeName}; WorkingDir: {app}; 
Name: {group}\{cm:UninstallProgram,{#MyAppName}{#MyAppDevelopVersion}}; Filename: {uninstallexe}; 
Name: "{commondesktop}\{#MyAppName}{#MyAppDevelopVersion}"; Filename: "{app}\bin\{#MyAppExeName}"; Tasks: desktopicon
Name: "{userappdata}\Microsoft\Internet Explorer\Quick Launch\{#MyAppName}{#MyAppDevelopVersion}"; Filename: {app}\bin\{#MyAppExeName}; 

[Run]
Filename: {app}\bin\{#MyAppExeName}; Description: {cm:LaunchProgram,{#MyAppName}}; Flags: nowait postinstall skipifsilent; WorkingDir: {app}; 


; For the Development Version,
; Do not delete setup files in the Systems User Application Directory
[UninstallDelete]
Type: files; Name: "{userappdata}\{#MyAppName}\mmexini.db3"
Type: files; Name: "{userappdata}\{#MyAppName}\Stocks\*.*"
Type: dirifempty; Name: "{userappdata}\{#MyAppName}\Stocks"
Type: dirifempty; Name: "{userappdata}\{#MyAppName}"

[Messages]
english.WelcomeLabel1=Welcome to [name] Setup
russian.WelcomeLabel1=Вас приветствует инсталлятор [name]
